﻿using System;
using System.Collections.Generic;

namespace State.CommandCenter.Step1
{
    public class TacticalPlan : TacticalComponent
    {
        private string _name;
        private string _description;
        private List<TacticalComponent> _tacticalComponents = new List<TacticalComponent>();

        public override string Name
        {
            get
            {
                return _name;
            }
        }

        public override string Description
        {
            get
            {
                return _description;
            }
        }

        public TacticalPlan(string planName, string planDescription)
        {
            _name = planName;
            _description = planDescription;
        }

        public override TacticalComponent this[int i]
        {
            get
            {
                return _tacticalComponents[i];
            }
        }

        public override void Add(TacticalComponent tacticalComponent)
        {
            _tacticalComponents.Add(tacticalComponent);
        }

        public override void Remove(TacticalComponent tacticalComponent)
        {
            _tacticalComponents.Remove(tacticalComponent);
        }

        public override void Print()
        {
            Console.WriteLine(string.Format("{0}", Description));
            Console.WriteLine(new string('-', Description.Length));
            Console.WriteLine();

            foreach (TacticalComponent tacticalComponent in _tacticalComponents)
            {
                tacticalComponent.Print();
            }

            /*
            // Look, an iterator:
            IEnumerator<TacticalComponent> tacticalComponent = _tacticalComponents.GetEnumerator();
            while (tacticalComponent.MoveNext())
            {
                tacticalComponent.Current.Print();
            }
            */
        }
    }
}
