﻿using System;
using System.Drawing;

namespace State.Units.States
{
    public class NormalState: IUnitState
    {
        private GameUnit _unit;

        public NormalState(GameUnit unit)
        {
            _unit = unit;
        }

        public void Move(Point newLocation)
        {
            _unit.Position = newLocation;
        }

        public void PerformShoot()
        {
            _unit.ShootingBehaviour.Shoot();
        }

        public void Kill()
        {
            _unit.Side = UnitSide.None;
            _unit.Description += ", Dead";

            _unit.SetState(_unit.GetDeadState());
        }

        public override string ToString()
        {
            return "Normal";
        }
    }
}
